
local function img2tab(mapDir)
	
	if not love.filesystem.exists(mapDir) then return nil end
	
	local palFileExists = love.filesystem.exists( mapDir..'/pal.png' )
	local listFileExists = love.filesystem.exists( mapDir..'/list.txt' )
	local map ={}
	local list ={}
	
	if listFileExists then
		
		local tabString = love.filesystem.read( mapDir..'/list.txt' )
		tabString = 'return '..tabString
		list = loadstring(tabString)()
	
	elseif palFileExists then

		local palImgData = love.image.newImageData( mapDir..'/pal.png' )
		list = {}
		palImgData:mapPixel(function(x, y, r, g, b, a)
			list[x+1] = {}
			list[x+1][1] = r * 65536 + g * 256 + b
			list[x+1][2] = r
			list[x+1][3] = g
			list[x+1][4] = b
         
			return r, g, b, a
		end)
 
	else
		error('palette and list files error')
	end
	
	
	local mapImgData = love.image.newImageData( mapDir..'/map.png' )
	local mapWidth, mapHeight = mapImgData:getDimensions()
	list.w = mapWidth
	list.h = mapHeight
	
	mapImgData:mapPixel(function(x, y, r, g, b, a)

		local color = r * 65536 + g * 256 + b
		for i,v in pairs(list) do
			if v[1] == color then
				map[x*mapHeight+y+1] = i
				break
			end
		end
		if not map[x*mapHeight+y+1] then error('color error') end

		return r, g, b, a
	end)
	
	
	return map, list
	
end

return img2tab