--[[
local tabToDraw = {
    [1] = { x=30, y=30, step=25, font=love.graphics.newFont(20), color={0,0,0,255} },
    [2] = { maxlines=6, x=200, y=30, step=15, font=love.graphics.newFont("DroidSans-Bold.ttf", 15), color={255,0,0,255} },
    [3] = { scroll=true, maxlines=nil, x=450, y=30, step=20, bmargin=100, font=love.graphics.newFont(14), color={0,0,255,255} },
}
table.insert(tabToDraw[1], "text line")
--]]

local function printTabs (tabToDraw)
  
  for _, tab in ipairs(tabToDraw) do
  
    local firstline, lastline
    
    if tab.scroll then
      if not tab.maxlines then
        tab.bmargin = tab.bmargin or 0
        tab.maxlines = math.floor((love.graphics.getHeight()-tab.y-tab.bmargin)/tab.step)
      end
      firstline = #tab - tab.maxlines
      firstline = firstline < 0 and 1 or firstline +1
      lastline = #tab
    else
      if tab.bmargin and not tab.maxlines then
        tab.maxlines = math.floor((love.graphics.getHeight()-tab.y-tab.bmargin)/tab.step)
      end
        firstline = 1
        lastline = tab.maxlines or #tab
    end

    love.graphics.setFont( tab.font )
    love.graphics.setColor( tab.color )
    local step = 0
    for i = firstline, lastline do
      if tab[i] then
        love.graphics.print( tab[i], tab.x, tab.y+step )
        step = step + tab.step
      end
    end
    
  end
end

return printTabs