
local printTabs = require 'd.printtabs'
local test = require 'test'

local S = { timeTab ={}, keys ={} }

S.cnt, S.maxcnt = 0, 100
S.timeTab.timerMultip = 2

S.testBlockByCnt = {
--[99] = true, [100] = true,
}



function love.load()
  
  S.tabsToDraw ={{
    x =16, y =40, step =20, color ={0,0,100,255},
    font =love.graphics.newFont ('d/DejaVuSansCondensed-Bold.ttf',16)
  }}

  
  S.mapDir = 'o02'
  S.checkTabs = false
  S.dumpTabsToTxt = false
  S.spaceToStop = false
  S.tilesToMove = 50
  S.periodNr = 100
  S.threadPeriod = 0.1
  S.dataChannelFloodLimit = 220

  S.tileSize = 10
  S.windowLmargin = 300
  S.windowMargin = 20
  S.scrollSpeed = 1000
  S.zoomSpeed = 1.5
  S.scale = 1
  S.drawToCanvas = false
    
  
  test.init (S, S.timeTab, S.tabsToDraw)
  
end


function love.keypressed (key)
  
  S.keys [key] = true
  
  if S.spaceToStop and S.keys['space'] and S.allowCheck then S.stoppedToCheck = true end
  
  if S.keys ['escape'] and S.allowQuit then love.event.quit()
  elseif S.keys ['return'] and S.allowDump then
    
    love.filesystem.write ('test.txt', '\n')
    for n=1, #S.tabsToDraw do
      for m=1, #S.tabsToDraw[n] do
        love.filesystem.append ('test.txt', S.tabsToDraw[n][m]..'\n')
      end
      love.filesystem.append ('test.txt', '\n\n')
    end
    love.event.quit()
    
  end
  
end


function love.keyreleased (key)
  
  S.keys [key] = nil
  
end


function love.update (dt)
  
  for i=1, #test.update do test.update [i](dt) end
  if test [S.cnt] and not S.testBlockByCnt [S.cnt] then test [S.cnt](S.cnt) end
  S.cnt = S.cnt < S.maxcnt and S.cnt +1 or S.cnt
  
end


function love.draw()
  
  love.graphics.setBackgroundColor (255,255,255,255)
  for i=1, #test.draw do test.draw [i](dt) end
  printTabs (S.tabsToDraw)
  love.graphics.print (love.timer.getFPS(),love.graphics.getWidth()-60,2)
  
end


function love.quit()
  
  if S.allowQuit and S.thread and S.thread:isRunning() then
    S.scc:push('stop')
    S.thread:wait()
  end
  return not S.allowQuit
  
end


function love.threaderror (thread,errorstr)
  
  print('Thread error!\n'..errorstr)
  
end