
local S, tabsToDraw, timeTab, Tf, Tu, Td, tu, td, StrToScr, StrSwap, Open, Close
local T = { update ={}, draw ={} }

local img2tab = require 'd.img-2-tab'



function T.init (...)
  
  S, timeTab, tabsToDraw = ...
	S.strPos ={}
  
  

  Tf (function(cnt) StrToScr (1,'PT5 ...') end)

  Tf (function(cnt) StrToScr (1,'','Map: '..S.mapDir) end)
  
  Tf (function(cnt)
    Open(cnt)
     
    S.mapTab, S.mapList = img2tab (S.mapDir)
    
    if not S.mapTab then
      StrToScr (1,'    Map error!','    ESC - quit')
      S.allowQuit = true
      S.cnt = S.maxcnt
    end
    
    Close(cnt, 1)
  end)



  Tf (function(cnt) StrToScr (1,'','Map tab to img ...') end)
  
  Tf (function(cnt)
    Open(cnt)
    
    -- atlas
		local additionalColor = {255,0,255,255}
		if S.drawToCanvas then
			S.atlas = love.graphics.newCanvas ( (#S.mapList +1) *(S.tileSize +2), S.tileSize +2 )
			S.atlas:setFilter ("nearest","nearest",0)
			S.atlas:renderTo (function()
        love.graphics.setBackgroundColor (255,255,255,255)
        for i,t in ipairs(S.mapList) do
          love.graphics.setColor (t[2],t[3],t[4],255)
          love.graphics.rectangle ("fill", (S.tileSize+2)*(i-1),0,S.tileSize+2,S.tileSize+2)
        end
        love.graphics.setColor (additionalColor)
        love.graphics.rectangle ("fill",(S.tileSize+2)*#S.mapList,0,S.tileSize+2,S.tileSize+2)
      end)
		else
			S.atlas = love.image.newImageData ( (#S.mapList +1) *(S.tileSize +2), S.tileSize +2 )
			for i,t in ipairs(S.mapList) do
				S.atlas:mapPixel(function (x,y,r,g,b,a) 
					return t[2],t[3],t[4],255
				end, (S.tileSize+2)*(i-1),0,S.tileSize+2,S.tileSize+2)
			end
			S.atlas:mapPixel(function (x,y,r,g,b,a) 
				return unpack(additionalColor)
			end, (S.tileSize+2)*#S.mapList,0,S.tileSize+2,S.tileSize+2)
			S.atlas = love.graphics.newImage (S.atlas)
		end
    
    -- quads
    S.quads ={}
    for i=1, #S.mapList +1 do
      S.quads[i] = love.graphics.newQuad ((i-1)*(S.tileSize +2)+1, 1, S.tileSize, S.tileSize, S.atlas:getWidth(),S.atlas:getHeight())
    end
    
    -- sbatch
    S.sbatch = love.graphics.newSpriteBatch (S.atlas, math.floor(S.mapList.w*S.mapList.h*2), 'stream')
    for x =0, S.mapList.w -1 do
      for y =0, S.mapList.h -1 do
        local i = x*S.mapList.h+y+1
        S.sbatch:add (S.quads[ S.mapTab[i] ], x*S.tileSize, y*S.tileSize)
      end 
    end
    
    S.imgWidth = S.mapList.w * S.tileSize
		S.imgHeight = S.mapList.h * S.tileSize
		
    -- canvas
		if S.drawToCanvas then
			S.img = love.graphics.newCanvas (S.imgWidth, S.imgHeight)
		else
			S.img = S.sbatch
    end
		  
    Close (cnt, 1)
  end)



  Tf (function(cnt) StrToScr (1,'','Thread init ...') end)

  Tf (function(cnt)
    
    S.thread = love.thread.newThread 'thread.lua'
    S.sc = love.thread.newChannel()
    S.dc = love.thread.newChannel()
    S.scc = love.thread.newChannel()
    S.dcc = love.thread.newChannel()
    
    -- colors list to flat array
    local listTab = {}
    listTab[1] = #S.mapList
    listTab[2] = #S.mapList[1]
    listTab[3] = S.mapList.w
    listTab[4] = S.mapList.h
    for i=1, listTab[1] do
      for j=1, listTab[2] do
        table.insert (listTab, S.mapList[i][j])
      end
    end
    
    S.thread:start (S.sc,S.dc,S.scc,S.dcc, S.threadPeriod, S.tilesToMove, S.mapTab, listTab, S.dumpTabsToTxt)
		
    S.dc:demand()
		
		listTab = nil
    
  end)


	
	Tf (function(cnt) StrToScr (1,'','Update and Draw init...') end)

  Tf (function(cnt)
    
    S.threadPeriodsCnt =0
    S.updateTime =0
		S.maxUpdateTime =0
    S.maxSlept =0
    S.maxChannelCnt =0    


    S.mapChanges ={}
    
		
		-- draw coords init
    S.drawWindow ={}
    S.drawWindow.x = S.windowLmargin
    S.drawWindow.y = S.windowMargin
    S.drawWindow.w = love.graphics.getWidth() -S.windowLmargin -S.windowMargin
    S.drawWindow.h = love.graphics.getHeight() -2 *S.windowMargin
    S.drawX = S.drawWindow.x /S.scale
    S.drawY = S.drawWindow.y /S.scale
		S.translX, S.translY = 0,0
    
    
		-- update function
    tu = function(dt)
      local time = love.timer.getTime()
      
      
      -- data channel flood limiter
      if S.dc:getCount() > S.dataChannelFloodLimit then
				
        S.sc:push (math.ceil(S.dc:getCount() / S.dataChannelFloodLimit) *(S.threadPeriod +S.updateTime) )
				
        if not S.strPos.FL then StrToScr (1,'') end
        S.strPos.FL = S.strPos.FL and S.strPos.FL or #S.tabsToDraw[1]
        S.cntFL = S.cntFL and S.cntFL +1 or 1
        StrSwap (1, S.strPos.FL, 'Channel limit reached!  '..S.cntFL..'  '..S.dc:getCount())
				
      end
        
        
      -- data receive
      local dccnt = S.dc:getCount()
      StrSwap (1, S.strPos[2], dccnt)
      S.maxChannelCnt = math.max (S.maxChannelCnt, dccnt)
      StrSwap (1, S.strPos[5], '   max: '..S.maxChannelCnt)
      
      while S.dc:getCount() > 0 do
          
        if type (S.dc:peek()) == 'table' then 
					
          --[[
          local from, fromx, fromy, fromv, to, tox, toy, tov = unpack (T.dc:pop())
          T.tab[to], T.tab[from] = T.tab[from], T.tab[to]
          table.insert(S.mapChanges, {from, fromx, fromy})
          table.insert(S.mapChanges, {to, tox, toy})
				  --]]
          
          local index, val = unpack ( S.dc:pop() )
          table.insert (S.mapChanges, index)
					S.mapTab[index] = val      
            
        elseif type (S.dc:peek()) == 'number' then
					
          S.threadSlept = S.dc:pop()
					
          S.maxSlept = math.max (S.maxSlept, S.threadSlept)
          StrSwap (1, S.strPos[3], string.format ('%.6f', S.threadSlept ))
          StrSwap (1, S.strPos[6], '   max: '..string.format ('%.6f', S.maxSlept ))
          S.threadPeriodsCnt = S.threadPeriodsCnt +1
          StrSwap (1, S.strPos[4], S.threadPeriodsCnt)
					
				end
          
      end
      
      
      -- sbatch update
      for i=1, #S.mapChanges do
        
        --[==[
        S.sbatch:set (
          S.mapChanges[i][1],
          S.quads[ S.mapTab[S.mapChanges[i][1]] ],
          S.mapChanges[i][2]*S.tileSize,
          S.mapChanges[i][3]*S.tileSize
          )
        --]==]
        
        local x = math.floor ((S.mapChanges[i] -1) /S.mapList.h)
        local y = (S.mapChanges[i] -1) %S.mapList.h
        
        S.sbatch:set (
          S.mapChanges[i],
          S.quads[ S.mapTab [S.mapChanges[i]] ],
          x*S.tileSize, y*S.tileSize
          )
        
        S.mapChanges[i] = nil
        
      end
      
			
      -- draw coords update
      if S.keys['up'] and not S.keys['down'] then
        S.drawY = S.drawY +S.scrollSpeed *dt
      elseif S.keys['down'] and not S.keys['up'] then
        S.drawY = S.drawY -S.scrollSpeed *dt
      end
      
      if S.keys['left'] and not S.keys['right'] then
        S.drawX = S.drawX +S.scrollSpeed *dt
      elseif S.keys['right'] and not S.keys['left'] then
        S.drawX = S.drawX -S.scrollSpeed *dt
      end
      
      if S.keys['pageup'] and not S.keys['pagedown'] then
				S.scale = S.scale +S.zoomSpeed *dt
      elseif S.keys['pagedown'] and not S.keys['pageup'] then
        S.scale = S.scale -S.zoomSpeed *dt
      end

			if 	S.imgWidth *S.scale <= S.drawWindow.w or S.imgHeight *S.scale <= S.drawWindow.h
			then S.scale = math.max (S.drawWindow.w/S.imgWidth, S.drawWindow.h/S.imgHeight) end
			
			S.scale = S.scale < 0.25 and 0.25 or S.scale
      S.scale = S.scale > 4 and 4 or S.scale
      
			S.translX = S.drawWindow.x +0.5*S.drawWindow.w -(S.drawWindow.x +0.5*S.drawWindow.w) *S.scale
			S.translY = S.drawWindow.y +0.5*S.drawWindow.h -(S.drawWindow.y +0.5*S.drawWindow.h) *S.scale
			
			S.drawX = (S.drawX +S.imgWidth) *S.scale +S.translX <= S.drawWindow.x +S.drawWindow.w
				and (S.drawWindow.x +S.drawWindow.w -S.translX) /S.scale -S.imgWidth
				or S.drawX
			S.drawY = (S.drawY +S.imgHeight) *S.scale +S.translY <= S.drawWindow.y +S.drawWindow.h
				and (S.drawWindow.y +S.drawWindow.h -S.translY) /S.scale -S.imgHeight
				or S.drawY
			
			S.drawX = S.drawX *S.scale +S.translX >= S.drawWindow.x
				and (S.drawWindow.x -S.translX) /S.scale
				or S.drawX
			S.drawY = S.drawY *S.scale +S.translY >= S.drawWindow.y
				and (S.drawWindow.y -S.translY) /S.scale
				or S.drawY
		
			
      -- tabs check
      if S.performCheck and not S.checkPerformed then
          
        if S.dumpTabsToTxt then
          love.filesystem.remove ('main_tab.txt')
          local file = love.filesystem.newFile ('main_tab.txt','a')
          for k,v in ipairs (S.mapTab) do
            file:write ( k..'	'..v..'\n' )
          end
          file:close()
        end

        if S.checkTabs or S.dumpTabsToTxt then 
					S.tabToCheck = S.dcc:demand()
        end
				
        if S.dumpTabsToTxt then
          love.filesystem.remove ('main_recived_tab.txt')
          local file = love.filesystem.newFile ('main_recived_tab.txt','a')
          for k,v in ipairs (S.tabToCheck) do
            file:write ( k..'	'..v..'\n' )
          end
          file:close()
        end
        
				if S.checkTabs and #S.mapTab ~= #S.tabToCheck then 
					S.checkFailed = true
        elseif S.checkTabs and #S.mapTab == #S.tabToCheck then
          for i=1, #S.mapTab do
            if S.mapTab[i] ~= S.tabToCheck[i] then
              S.checkFailed = true
              break
            end
          end
				end
				
        if S.checkTabs and S.checkFailed then
          StrToScr (1,'','Tabs check ...','  Failed!')
        elseif S.checkTabs and not S.checkFailed then
          StrToScr (1,'','Tabs check ...','  OK')
        end

        S.checkPerformed = true 
      end
      
      
			-- tabs check init
      if  ( S.spaceToStop and S.stoppedToCheck
          or not S.spaceToStop and S.threadPeriodsCnt >= S.periodNr ) 
          and not S.checkPerformed
			then
        S.performCheck = true
        S.scc:push('check')
      end
      
			
			-- update func time summary
      S.updateTime = love.timer.getTime() -time
			if not (S.performCheck or S.dumpTabsToTxt) then
				S.maxUpdateTime = math.max (S.maxUpdateTime, S.updateTime)
			end
      StrSwap (1, S.strPos[1], string.format ('%.6f', S.updateTime))
			StrSwap (1, S.strPos[7], '   max: '..string.format ('%.6f', S.maxUpdateTime))
    end



    -- drawing func
    td = function()
      
      -- canvas
			if S.drawToCanvas then
				S.img:setFilter ("nearest", "nearest", 0)
				S.img:renderTo( function ()
					love.graphics.clear()
					love.graphics.setBackgroundColor (255,255,255,255)
					love.graphics.setColor (255,255,255,255)
					love.graphics.draw (S.sbatch, 0, 0)
				end)
			end
      
			
      -- screen
      love.graphics.setScissor (S.drawWindow.x, S.drawWindow.y, S.drawWindow.w, S.drawWindow.h)
      
      love.graphics.push()
			love.graphics.translate (S.translX, S.translY)
      love.graphics.scale (S.scale, S.scale)
      love.graphics.setColor (255,255,255,255)
      --love.graphics.setBlendMode ("alpha", "premultiplied")
      love.graphics.draw (S.img, S.drawX, S.drawY)
      love.graphics.pop()

      love.graphics.setScissor()
      
      love.graphics.draw (S.atlas, 0, 0, 0, 10/S.tileSize, 10/S.tileSize)
      
      love.graphics.setColor (0,0,0,255)
      love.graphics.rectangle ("line", S.drawWindow.x-1, S.drawWindow.y-1, S.drawWindow.w+2, S.drawWindow.h+2)
      
    end


  end)

  
	Tf (function(cnt)
    StrToScr (1,'','Drawing ...','',
      'update time:','','','data channel counter:','','',
      'thread slept:','','','period counter:','',''
			)
    S.strPos[1], S.strPos[2] = #S.tabsToDraw[1]-10, #S.tabsToDraw[1]-7
    S.strPos[3], S.strPos[4] = #S.tabsToDraw[1]-4, #S.tabsToDraw[1]-1
    S.strPos[5], S.strPos[6] = #S.tabsToDraw[1]-6, #S.tabsToDraw[1]-3
    S.strPos[7] = #S.tabsToDraw[1]-9
		
		Tu(tu); Td(td)
		tu, td = nil, nil
  end)


  Tf (function(cnt)
    StrToScr (1,'',
			'Arrows, PgUp, PgDn',
      'ESC - quit',
      'ENTER - dump scr to txt and quit'
			)
		if S.spaceToStop then StrToScr (1,'SPACE - stop to check') end
		
    S.allowQuit, S.allowDump, S.allowCheck = true,true,true
  end)
  

end



function Tf (func)
  table.insert (T, func)
end

function Tu (func)
  table.insert (T.update, func)
end

function Td (func)
  table.insert (T.draw, func)
end

function StrToScr (tab, ...)
  for _,str in ipairs{...} do
    table.insert (tabsToDraw [tab], str)
  end
end

function StrSwap (tab, pos, str)
  table.remove (tabsToDraw [tab], pos)
  table.insert (tabsToDraw [tab], pos, str)
end

function Open (cnt, tab, ...)
  StrToScr (tab, ...)
  timeTab [timeTab.timerMultip * cnt] = love.timer.getTime()
end

function Close (cnt, tab, ...)
  timeTab [ timeTab.timerMultip *(cnt +1) -1 ] = love.timer.getTime()
  table.insert (tabsToDraw [tab],
    '    Done.     time: '.. string.format ('%.6f',
      timeTab [ timeTab.timerMultip *(cnt +1) -1 ] -timeTab [ timeTab.timerMultip *cnt ] )
    )
  StrToScr (tab, ...)
end


return T